<template>
    <div class="row q-col-gutter-md text-center">
      <!-- Scan For PoS! -->
      <div class="col-12 col-md-6">
        <p>This QR Code should be <strong>staff facing</strong>.</p>
        <p>It is used by staff to set the amount due.</p>

        <div class="scissor-container column justify-center">
          <div class="col">
            <img class="scissor-container-logo" src="https://bitcoincash.org/img/green/bitcoin-cash-logo-horizontal.svg" />
          </div>
          <div class="col-auto">
            <a class="scissor-container-qr-code" :href="merchantQRCodeUrl" target="_blank">
              <img class="text-center" ref="merchantQRCodeElement" />
            </a>
          </div>
          <div class="col">
            <div class="scissor-container-cta">Scan To Receive!</div>
          </div>
          <div class="col">
            <div class="scissor-container-terminal-id">Terminal ID: {{ terminalId }}</div>
          </div>
        </div>
      </div>

      <!-- Scan To Pay! -->
      <div class="col-12 col-md-6">
        <p>This QR Code should be <strong>customer facing</strong>.</p>
        <p>It is used by the customer to pay the set amount.</p>

        <div class="scissor-container column justify-center">
          <div class="col">
            <img class="scissor-container-logo" src="https://bitcoincash.org/img/green/bitcoin-cash-logo-horizontal.svg" />
          </div>
          <div class="col-auto">
            <a class="scissor-container-qr-code" :href="paymentQRCodeUrl" target="_blank">
              <img class="text-center" ref="paymentQRCodeElement" />
            </a>
          </div>
          <div class="col">
            <div class="scissor-container-cta">Scan To Pay!</div>
          </div>
          <div class="col">
            <div class="scissor-container-terminal-id">Terminal ID: {{ terminalId }}</div>
          </div>
        </div>
      </div>

    </div>
</template>

<script setup lang="ts">
// Vue Imports.
import { ref, onMounted } from 'vue'

// Third-party imports.
import { generateQrCode, generateShortId, generatePassword } from '../lib/utils.js'

// Properties
const props = defineProps<{
  terminalId?: string,
  terminalPassword?: string
}>()

// Set references to our reactive Vue Elements.
const terminalId = ref<string>('')
const terminalPassword = ref<string>('')
const merchantQRCodeUrl = ref<string>('')
const paymentQRCodeUrl = ref<string>('')
const merchantQRCodeElement = ref<HTMLImageElement>()
const paymentQRCodeElement = ref<HTMLImageElement>()

// Define constants.
terminalId.value = props.terminalId || generateShortId()
terminalPassword.value = props.terminalPassword || generatePassword()

// Set references to our reactive Vue Elements.
merchantQRCodeUrl.value = `${process.env.SELF_URL}/#/t/${terminalId.value}/${terminalPassword.value}`
paymentQRCodeUrl.value = `bitcoincash:?r=${process.env.API_URL}/pay/${terminalId.value}`

// When our Vue component is mounted...
onMounted(async (): Promise<void> => {
  // Make sure our paymentQRCodeElement was found.
  if (!paymentQRCodeElement.value) {
    throw new Error('Could not find paymentQRCodeElement')
  }

  // Make sure our merchantQRCodeElement was found.
  if (!merchantQRCodeElement.value) {
    throw new Error('Could not find merchantQRCodeElement')
  }

  // Render the Payment QR Code.
  const paymentQRImage = await generateQrCode(paymentQRCodeUrl.value)
  const paymentImageSrc = window.URL.createObjectURL(paymentQRImage)
  paymentQRCodeElement.value.setAttribute('src', paymentImageSrc)

  // Render the Merchant QR Code.
  const merchantQRImage = await generateQrCode(merchantQRCodeUrl.value)
  const merchantImageSrc = window.URL.createObjectURL(merchantQRImage)
  merchantQRCodeElement.value.setAttribute('src', merchantImageSrc)
})
</script>

<style lang="scss">
  .scissor-container {
    width: 110mm;
    height: 110mm;
    text-align: center;
    border: 1px dashed #000;
    padding: 12mm;
    margin: auto;
  }

  .scissor-container-logo {
    width: 60mm;
    margin-bottom: 1em;
  }

  .scissor-container-qr-code img {
    max-width: 100%;
    max-height: 100%;
  }

  .scissor-container-cta {
    font-weight:bold;
    font-size:2.0em;
  }

  .scissor-container-terminal-id {
    font-size:0.7em;
    color: #666;
  }
</style>
